﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using System.Reflection;
using System.Collections;
using System.Threading.Tasks;
using System.Linq;
using Utility01;

namespace Torture
{
    public class Mod
    {
        public static void OnLoad()
        {
            Utility.ModMetaCache(ModAPI.Metadata.MetaLocation);
            if (!Utility.IsFolderExists(@"Mods\\01STUDIO\\Torture"))
            {
                Utility.CreateFolder(@"Mods\\01STUDIO\\Torture");
                DialogBox trailer = (DialogBox)null;
                DialogBox discordInvite = (DialogBox)null;
                trailer = DialogBoxManager.Dialog("Hello, my little lover of torment, do you want to see what I have prepared for you with my team?", new DialogButton[]
                {
                    new DialogButton("Let's skip this", true, () =>
                    {
                        Utility.ShowDialog(discordInvite);
                    }),
                    new DialogButton("Absolutely, let's see", true, () =>
                    {
                        Utility.OpenLink("https://youtu.be/TdZGXQy5Ofo");
                        Utility.ShowDialog(discordInvite);
                    })
                });
                discordInvite = DialogBoxManager.Dialog("Hi, this mod is one of the biggest I've ever done\nA huge amount of work has been done in it, below you can leave your feedback.", new DialogButton[]
                {
                    new DialogButton("Join the community on Discord", false, () =>
                    {
                        Utility.OpenLink("https://discord.gg/tUvF8jmbWm");
                    }),
                    new DialogButton("Support Team 01", false, () =>
                    {
                        Utility.OpenLink("https://01studio.ru/donate");
                    }),
                    new DialogButton("Close forever", true, () => DialogBoxManager.Notification("Thanks for installing the mod. \nYours 01 Studio"))
                });
                Utility.HideDialog(discordInvite);
            }
            else
            {
                if (PlayerPrefs.GetInt("TortureModUpdates", 0) <= 0)
                {
                    DialogBox shredderUpdate = (DialogBox)null;
                    shredderUpdate = DialogBoxManager.Dialog("<size=120%><align=\"center\">Torture Mod - <color=\"red\">SHREDDER<color=\"white\"> UPDATE\n<size=100%><align=\"left\">" +
                        "What's new?\r\n+ New item - Shredder\r\n+ All items for convenience were placed in a separate category\n\nI also ask you to watch the new video. so you will greatly help me and my channel! If the video gets good activity, \nI will think about a new update of this mod. If you want to support me, you can click on the buttons you need", new DialogButton[]
                        {
                            new DialogButton("Watch video", false, () => Utility.OpenLink("https://youtu.be/i6JKNmW_NKU")),
                            new DialogButton("Discord Server", false, () => Utility.OpenLink("https://discord.gg/tUvF8jmbWm")),
                            new DialogButton("Patreon and Boosty", false, () => Utility.OpenLink("https://01studio.ru/donate")),
                            new DialogButton("Close", true, () => PlayerPrefs.SetInt("TortureModUpdates", 1))
                        });
                }
            }
        }
        public static void Main()
        {
            var spriteCategory = ModAPI.LoadSprite("Sprites/Other/category.png");
            spriteCategory.texture.filterMode = FilterMode.Trilinear;
            Utility.RegisterCategory("Torture Mod", "For my little lover of torment", spriteCategory);
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Bear Trap",
                NameToOrderByOverride = "Torture1",
                DescriptionOverride = "A device designed to catch or kill a victim, as well as serving as a protective barrier.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/bearTrap_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Bear Trap/";
                    Sprite[] sprites = new Sprite[] { ModAPI.LoadSprite(path + "left.png"), ModAPI.LoadSprite(path + "plate.png"), ModAPI.LoadSprite(path + "right.png") };

                    var behaviour = gameObject.GetOrAddComponent<BearTrapBehaviour>();
                    behaviour.sprites = sprites;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Shredder",
                NameToOrderByOverride = "Torture1",
                DescriptionOverride = "Will turn your life into a mess",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/shredder.png"),
                AfterSpawn = (gameObject) =>
                {
                    gameObject.SetSprite(ModAPI.LoadSprite("Sprites/Art/Shredder/front.png"), false, "Foreground");
                    var background = Utility.CreateChildObject("background", gameObject.transform);
                    var button = Utility.CreateChildObject("button", gameObject.transform);
                    button.SetSprite(ModAPI.LoadSprite("Sprites/Art/Shredder/button.png"), false, "Foreground", 5);
                    Utility.SetPositionWithOffSet(button.transform, gameObject.transform);
                    Utility.SetPositionWithOffSet(background.transform, gameObject.transform);
                    background.SetSprite(ModAPI.LoadSprite("Sprites/Art/Shredder/back.png"), false, "Background", 0);
                    foreach (var collider in gameObject.GetComponents<Collider2D>())
                    {
                        collider.Destroy();
                    }
                    var newCollider = gameObject.GetOrAddComponent<PolygonCollider2D>();
                    newCollider.pathCount = 1;
                    newCollider.SetPath(0, new Vector2[]
                    {
                       new Vector2(1.561269f, 1.003572f),
                       new Vector2(1.481099f, 0.3621852f),
                       new Vector2(1.469161f, -0.4799509f),
                       new Vector2(1.468489f, -0.8071818f),
                       new Vector2(-1.197911f, -0.7998226f),
                       new Vector2(-1.195367f, 0.3779852f),
                       new Vector2(-1.292204f, 1.002736f),
                       new Vector2(-1.654395f, 1.002722f),
                       new Vector2(-1.654395f, 0.9483018f),
                       new Vector2(-1.372751f, 0.2176563f),
                       new Vector2(-1.336857f, 0.2139914f),
                       new Vector2(-1.34496f, 0.1142707f),
                       new Vector2(-2.141483f, 0.1142599f),
                       new Vector2(-2.171349f, 0.08054125f),
                       new Vector2(-2.230787f, -0.01374102f),
                       new Vector2(-2.262544f, -0.1210642f),
                       new Vector2(-2.259742f, -0.516673f),
                       new Vector2(-2.231484f, -0.573992f),
                       new Vector2(-2.138617f, -0.6368954f),
                       new Vector2(-2.050923f, -0.6612551f),
                       new Vector2(-1.420397f, -0.7737234f),
                       new Vector2(-1.345085f, -0.7764156f),
                       new Vector2(-1.343204f, -0.8253241f),
                       new Vector2(-1.403063f, -0.8339338f),
                       new Vector2(-1.400837f, -0.9989164f),
                       new Vector2(-0.9989982f, -0.9984467f),
                       new Vector2(-0.9990225f, -0.9409575f),
                       new Vector2(1.28781f, -0.9448853f),
                       new Vector2(1.287603f, -1.000961f),
                       new Vector2(1.68507f, -0.9988484f),
                       new Vector2(1.6853f, -0.827879f),
                       new Vector2(1.626417f, -0.8285935f),
                       new Vector2(1.625507f, -0.7158639f),
                       new Vector2(1.658173f, -0.7170739f),
                       new Vector2(2.150318f, -0.2252475f),
                       new Vector2(2.152887f, -0.2029042f),
                       new Vector2(2.255147f, -0.2008445f),
                       new Vector2(2.251305f, -0.1011152f),
                       new Vector2(2.179546f, -0.1044974f),
                       new Vector2(1.623502f, -0.6844316f),
                       new Vector2(1.606592f, -0.01305604f),
                       new Vector2(2.173389f, 0.5848393f),
                       new Vector2(2.258765f, 0.5999005f),
                       new Vector2(2.259463f, 0.6620421f),
                       new Vector2(2.178853f, 0.6647377f),
                       new Vector2(1.663589f, 0.1524785f),
                       new Vector2(1.627285f, 0.1164229f),
                       new Vector2(1.629213f, 0.2229836f),
                       new Vector2(1.657023f, 0.2241557f),
                       new Vector2(1.943191f, 0.9430401f),
                       new Vector2(1.94238f, 1.004045f)
                    });
                    var shredder = gameObject.GetOrAddComponent<Shredder>();
                    shredder.audioClips = new AudioClip[]
                    {
                        ModAPI.LoadSound("Sounds/Shredder/motor.mp3"),
                        ModAPI.LoadSound("Sounds/Shredder/switch.mp3"),
                        ModAPI.LoadSound("Sounds/Shredder/clean.mp3"),
                    };
                    var buttonRenderer = button.GetComponent<SpriteRenderer>();
                    buttonRenderer.material = ModAPI.FindMaterial("VeryBright");
                    shredder.buttonRenderer = buttonRenderer;
                    var smoke = Utility.CreateChildObject(ModAPI.FindSpawnable("Particle Projector").Prefab.transform.Find("smoke").gameObject, gameObject.transform);
                    Utility.SetPositionWithOffSet(smoke.transform, gameObject.transform, -1.8f, -0.8f);
                    smoke.transform.eulerAngles = new Vector3(0, 0, 30);
                    shredder.smoke = smoke.GetComponent<ParticleSystem>();
                    var debris = Utility.CreateChildObject(ModAPI.FindSpawnable("Human").Prefab.transform.Find("Head/brain matter particles").gameObject, gameObject.transform);
                    Utility.SetPositionWithOffSet(debris.transform, gameObject.transform, 1.5f);
                    debris.transform.eulerAngles = new Vector3(0, 0, 18.07f);
                    var debrisParticleSystem = debris.GetComponent<ParticleSystem>();
                    var debrisMain = debrisParticleSystem.main;
                    debrisMain.loop = false;
                    debrisMain.startLifetime = 1;
                    var debrisStartColor = debrisMain.startColor;
                    debrisStartColor.mode = ParticleSystemGradientMode.Color;
                    debrisStartColor.color = Color.red;
                    debrisMain.startColor = debrisStartColor;
                    var debrisEmission = debrisParticleSystem.emission;
                    debrisEmission.rateOverTime = 555;
                    shredder.debris = debrisParticleSystem;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Guillotine Blade",
                NameToOrderByOverride = "Torture2",
                DescriptionOverride = "A very sharpened piece of metal.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/guillotineBlade_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Guillotine Blade/";
                    Utility.SetSprite(gameObject, ModAPI.LoadSprite(path + "sprite.png"));
                    gameObject.AddComponent<FlatSliceBlade>();
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Skin Removal Knife",
                NameToOrderByOverride = "Torture3",
                DescriptionOverride = "Its blade is not clearly sharpened and any of its holding on the surface of your skin will lead to damage, be careful",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/skinRemovalKnife_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Skin Removal Knife/";
                    Sprite[] sprites = new Sprite[] { ModAPI.LoadSprite(path + "sprite.png") };
                    gameObject.SetSprite(sprites[0]);
                    var physicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
                    physicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                    physicalBehaviour.HoldingPositions = new Vector3[] { new Vector3(0, 0, 0) };
                    gameObject.AddComponent<SkinRemovalBlade>();
                    physicalBehaviour.ResetColliderArray();


                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Katana",
                NameToOrderByOverride = "Torture4",
                DescriptionOverride = "A long Japanese sword. The shape of the katana blade resembles a saber, but the handle is straight and long, which allows you to use a two-handed grip. The pommel is missing.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/katana_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Katana/";
                    Sprite[] sprites = new Sprite[] { ModAPI.LoadSprite(path + "katana.png") };
                    Utility.SetSprite(gameObject, sprites[0], false);
                    UnityEngine.Object.Destroy(gameObject.GetComponent<Collider2D>());
                    var objectCollider = gameObject.AddComponent<BoxCollider2D>();
                    objectCollider.size = new Vector2(1.3286f, 0.1f);
                    objectCollider.offset = new Vector2(0.05f, 0.01f);
                    var handlePhysicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
                    handlePhysicalBehaviour.HoldingPositions = new Vector3[] { new Vector3(-0.4f, 0, 0) };
                    var bladeBehaviour = gameObject.AddComponent<FlatSliceBlade>();
                    bladeBehaviour.axis = Vector2.right;
                    bladeBehaviour.looseLower = false;
                    bladeBehaviour.looseUpper = true;
                    bladeBehaviour.higherLimit = 0.4f;
                    GameObject point = Utility.CreateChildObject("point", gameObject.transform);
                    var boxCollider = point.AddComponent<BoxCollider2D>();
                    boxCollider.isTrigger = true;
                    boxCollider.size = new Vector2(0.9f, 0.1f);
                    Utility.SetPositionWithOffSet(point.transform, gameObject.transform, 0.3276f, -0.1012f);
                    var actOnCollide = gameObject.AddComponent<ActOnCollideOwn>();
                    actOnCollide.DispatchChance = 1f;
                    actOnCollide.ImpactForceThreshold = 0.4f;
                    actOnCollide.Actions = (collision) =>
                    {
                        var colliders = Utility.InCollider(boxCollider);
                        if (colliders.Contains(collision.collider))
                        {
                            if (collision.gameObject.TryGetComponent<LimbBehaviour>(out LimbBehaviour limb))
                            {
                                limb.Slice();
                            }
                        }
                    };
                    handlePhysicalBehaviour.ResetColliderArray();
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Microwave Oven",
                NameToOrderByOverride = "Torture1",
                DescriptionOverride = "An electrical appliance that allows you to warm up water-containing substances due to electromagnetic radiation of the decimeter range and designed for fast cooking, heating or defrosting of food.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/microwave_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Microwave/";
                    string pathSounds = "Sounds/Microwave/";
                    var microwaveBehaviour = gameObject.AddComponent<Microwave>();
                    microwaveBehaviour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "background.png"), ModAPI.LoadSprite(path + "glass.png"), ModAPI.LoadSprite(path + "foreground.png") };
                    microwaveBehaviour.audioClips = new AudioClip[] { ModAPI.LoadSound(pathSounds + "rumble.wav"), ModAPI.LoadSound(pathSounds + "ding.wav") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Freezer",
                NameToOrderByOverride = "Torture2",
                DescriptionOverride = "A device that maintains a low temperature in a thermally insulated chamber.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/freezer_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Freezer/";
                    var freezerBehaviour = gameObject.AddComponent<Freezer>();
                    freezerBehaviour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "sides.png"), ModAPI.LoadSprite(path + "transparent_foreground.png"), ModAPI.LoadSprite(path + "foreground.png"), ModAPI.LoadSprite(path + "door.png") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Circular Table",
                NameToOrderByOverride = "Torture3",
                DescriptionOverride = "A machine designed for longitudinal, transverse sawing and angled sawing of wood and other materials.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/circularTable_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Circular Table/";
                    string pathSounds = "Sounds/Saw/";
                    var circularTableBehaviour = gameObject.AddComponent<CircularTable>();
                    circularTableBehaviour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "table.png"), ModAPI.LoadSprite(path + "saw.png") };
                    circularTableBehaviour.audioClips = new AudioClip[] { ModAPI.LoadSound(pathSounds + "Middle_Saw.mp3") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Water Torture Cell",
                NameToOrderByOverride = "Torture4",
                DescriptionOverride = "Fill this chamber with any liquid you want. And if it happens, put a human being in there.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/waterCell_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Water Torture Cell/";
                    var waterTortureCell = gameObject.GetOrAddComponent<WaterTortureCell>();
                    waterTortureCell.sprites = new Sprite[] { ModAPI.LoadSprite(path + "sprite.png") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                CategoryOverride = ModAPI.FindCategory("Torture Mod"),
                NameOverride = "[Torture Mod] Shocker",
                NameToOrderByOverride = "Torture5",
                DescriptionOverride = "A weapon whose principle of operation is based on the direct action of an electric discharge on a live target is one of the devices for self-defense. It belongs to the class of non-lethal weapons.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/shocker_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Shocker/";
                    string pathSounds = "Sounds/Shocker/";
                    var shockerBehvaiour = gameObject.AddComponent<Shocker>();
                    shockerBehvaiour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "sprite.png") };
                    shockerBehvaiour.audioClips = new AudioClip[] { ModAPI.LoadSound(pathSounds + "shocker.wav") };
                }
            });
            var buttonsSprites = new Sprite[]
            {
                Utility.LoadSprite("Thumbs/patreon.png"),
                Utility.LoadSprite("Thumbs/boosty.png"),
                Utility.LoadSprite("Thumbs/discord.png"),
                Utility.LoadSprite("Thumbs/yt.png")
            };
            foreach (var sprite in buttonsSprites)
            {
                sprite.texture.filterMode = FilterMode.Trilinear;
            }
            Utility.AddButtonInCatalog("Patreon", "", "Torture Mod", buttonsSprites[0], 0, () => Utility.OpenLink("https://www.patreon.com/01STUDIO"));
            Utility.AddButtonInCatalog("Boosty", "", "Torture Mod", buttonsSprites[1], 1, () => Utility.OpenLink("https://boosty.to/dyadyushkadyadya"));
            Utility.AddButtonInCatalog("Discord", "", "Torture Mod", buttonsSprites[2], 2, () => Utility.OpenLink("https://01studio.ru/discord"));
            Utility.AddButtonInCatalog("YouTube", "", "Torture Mod", buttonsSprites[3], 3, () => Utility.OpenLink("https://youtu.be/i6JKNmW_NKU"));
        }
    }
}